
typedef struct{
	GtkWidget *inputVideoEntry;
	GtkWidget *inputAudioEntry;
	GtkWidget *outputVideoEntry;
	GtkWidget *importModuleCombo;
	GtkWidget *importFramesEntry;
	GtkWidget *probedLabel;
	GtkWidget *transcodeCommandLineEntry;
	GtkWidget *videoProcessingVbox;
	GtkWidget *exportModuleCombo;
	GtkWidget *exportModuleStringEntry;
	GtkWidget *exportFramerateCombo;
	GtkWidget *exportDeinterCombo;
	GtkWidget *exportAntialiasCombo;
	GtkWidget *exportVideoBitrateEntry;
	GtkWidget *fileSizeVideo;
	GtkWidget *fileSizeVideoOverhead;
	GtkWidget *fileSizeAudio;
	GtkWidget *fileSizeAudioOverhead;
	GtkWidget *fileSizeTotal;
	GtkWidget *exportSizeWidthEntry;
	GtkWidget *exportSizeHeightEntry;
	GtkWidget *audioProcessingVbox;
	GtkWidget *exportAudioFormatCombo;
	GtkWidget *exportAudioBitrateCombo;
	GtkWidget *exportAudioGainEntry;
	GtkWidget *progressBar;
	GtkWidget *transcodeOutputText;
	gint aspectLock;
	gint dirtyTranscodeLine;
} interface_struct;

typedef struct{
	gint process_video;
	gint process_audio;
	gint aspectRatio;
	gint yuv;
	gint swapRB;
	gint flip;
	gint mirror;
	gint running;
} output_config_struct;

GtkWidget * create_main_window(void);
GSList *AddRadioButton(GtkWidget *box, gchar *label, gint value, GSList *group);

/* stuff to go in callbacks eventually */

void CloseTheApp(GtkWidget *window, gpointer data);
void MenuTranscodeLine(GtkMenuItem *menuitem,gpointer data);
void MakeTranscodeLine(void);
void StopTranscode(GtkWidget *Entry, gpointer data);
void UpdateTranscodeLine(GtkWidget *Entry, gpointer data);
void UpdateVideoSize(GtkWidget *Entry, gpointer data);
void UpdateAudioSize(GtkWidget *Entry, gpointer data);
void UpdateProjectedFileSize(void);
void MenuGO(GtkMenuItem *menuitem,gpointer data);
void MenuQuit(GtkMenuItem *menuitem,gpointer data);
void MenuAbout(GtkMenuItem *menuitem,gpointer data);
void RadioClicked(GtkToggleButton *button,gpointer data);
void ToggleAspectRatio(GtkWidget *window, gpointer data);
void ToggleButton(GtkWidget *window, gpointer data);
void ProbeVideoFile(GtkWidget *Entry, gpointer data);
void UpdateRatioWidth(GtkWidget *Entry, gpointer data);
void UpdateRatioHeight(GtkWidget *Entry, gpointer data);
void MakeBrowseWindow(GtkButton *button, gpointer data);
void MakeBrowseWindowOutput(GtkButton *button, gpointer data);
void FileselOK(GtkButton *button,gpointer data);
void FileselOKOutput(GtkButton *button,gpointer data);
void FileselCANCEL(GtkButton *button,gpointer data);
void SetDirty(void);
void MakeTranscodeDialog(void);
void ShowMessage( gchar * textmessage );
void CloseDialog( GtkButton * button, gpointer data );
GtkWidget *AddWidget(GtkWidget * widget, GtkWidget * packingbox);



